###############################################################################
# ContactPageSettings.pm                                                      #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.7.00                                                 #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2016 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
###############################################################################
use strict;
no strict qw(refs);
use warnings;
use CGI::Carp qw(fatalsToBrowser);
our $VERSION = '2.7.00';

our $contactpagesettingspmver = 'YaBB 2.7.00 $Revision: 0.10 $';
our ($action);
$action ||= q{};
if ( $action eq 'detailedversion' ) { return 1; }

#system
our (
    $adminurl,      $langdir, $language, $vardir, $yymain,
    $yysetlocation, %croak,   %FORM,     %mod_list,
);

#Mod
our (
    $autores_email,  $autores_name,       $autores_pre,
    $autores_sub,    $contact_admin_main, $contact_auto,
    $contact_email,  $contact_subjects,   $en_contact_auto,
    $en_contactpage, $en_selfcopy,        $en_valimage,
    $en_valquest,    $maxconmeslen,       $my_contact_admin_spam,
    $selfcopy_email, $selfcopy_name,      $selfcopy_pre,
    $subject_pre,    %contactadmin_txt,
);

if ( !-e "$vardir/Mods/ContactPage.txt" ) { contact_page2(); }
require 'Variables/Mods/ContactPage.txt';

load_language('Mods/ContactPage');
load_language('Admin');
get_template('Mods/ContactPage');

sub contact_page {

    is_admin_or_gmod();
    my $chkselfcopy =
qq~                    <input type="checkbox" name="en_selfcopy" id="en_selfcopy" value="1"${ischecked($en_selfcopy)} />~;
    my $chkcontact_auto =
qq~                    <input type="checkbox" name="en_contact_auto" id="en_contact_auto" value="1"${ischecked($en_contact_auto)} />~;

    chomp $contact_subjects;
    $contact_subjects =~ s/[|]/\n/gxsm;
    $contact_auto =~ s/<br\s\/>/\n/gxsm;
    $contact_email =~ s/\\//gxsm;
    $autores_email =~ s/\\//gxsm;
    $selfcopy_email =~ s/\\//gxsm;

    my $contact_spam = q{};
    if ( -e "$langdir/$language/spam.questions" ) {
        $contact_spam = $my_contact_admin_spam;
        my $selvalq =
qq~                        <option value="0"${isselected(!$en_valquest || $en_valquest==0)}>$contactadmin_txt{'02'}</option>
                        <option value="1"${isselected($en_valquest==1)}>$contactadmin_txt{'17'}</option>
                        <option value="2"${isselected($en_valquest==2)}>$contactadmin_txt{'04'}</option>~;
        $contact_spam =~ s/\Q{yabb selvalq}\E/$selvalq/gxsm;
    }
    my $selcon =
qq~                        <option value="0"${isselected(!$en_contactpage || $en_contactpage==0)}>$contactadmin_txt{'02'}</option>
                        <option value="2"${isselected($en_contactpage==2)}>$contactadmin_txt{'03'}</option>
                        <option value="1"${isselected($en_contactpage==1)}>$contactadmin_txt{'04'}</option>~;
    my $selval =
qq~                    <option value="0"${isselected(!$en_valimage || $en_valimage==0)}>$contactadmin_txt{'02'}</option>
                        <option value="1"${isselected($en_valimage==1)}>$contactadmin_txt{'17'}</option>
                        <option value="2"${isselected($en_valimage==2)}>$contactadmin_txt{'04'}</option>~;

    $yymain = $contact_admin_main;
    $yymain =~ s/\Q{yabb selcon}\E/$selcon/gxsm;
    $yymain =~ s/\Q{yabb contact_email}\E/$contact_email/gxsm;
    $yymain =~ s/\Q{yabb subject_pre}\E/$subject_pre/gxsm;
    $yymain =~ s/\Q{yabb contact_subjects}\E/$contact_subjects/gxsm;
    $yymain =~ s/\Q{yabb MaxConMesLen}\E/$maxconmeslen/gxsm;
    $yymain =~ s/\Q{yabb selval}\E/$selval/gxsm;
    $yymain =~ s/\Q{yabb contact_spam}\E/$contact_spam/gxsm;
    $yymain =~ s/\Q{yabb chkselfcopy}\E/$chkselfcopy/gxsm;
    $yymain =~ s/\Q{yabb selfcopy_email}\E/$selfcopy_email/gxsm;
    $yymain =~ s/\Q{yabb selfcopy_name}\E/$selfcopy_name/gxsm;
    $yymain =~ s/\Q{yabb autores_sub}\E/$autores_sub/gxsm;
    $yymain =~ s/\Q{yabb chkcontact_auto}\E/$chkcontact_auto/gxsm;
    $yymain =~ s/\Q{yabb contact_auto}\E/$contact_auto/gxsm;
    $yymain =~ s/\Q{yabb autores_email}\E/$autores_email/gxsm;
    $yymain =~ s/\Q{yabb autores_name}\E/$autores_name/gxsm;
    $yymain =~ s/\Q{yabb autores_pre}\E/$autores_pre/gxsm;

    our $yytitle     = $mod_list{'contact1'};
    our $action_area = 'contactpage';
    admintemplate();
    exit;
}

sub contact_page2 {
    is_admin_or_gmod();

    $en_contactpage   = $FORM{'en_contactpage'}   || 0;
    $contact_email    = $FORM{'contact_email'}    || q{};
    $en_valimage      = $FORM{'en_valimage'}      || 0;
    $en_valquest      = $FORM{'en_valquest'}      || 0;
    $maxconmeslen     = $FORM{'MaxConMesLen'}     || 2000;
    $en_selfcopy      = $FORM{'en_selfcopy'}      || 0;
    $selfcopy_email   = $FORM{'selfcopy_email'}   || q{};
    $selfcopy_name    = $FORM{'selfcopy_name'}    || q{};
    $selfcopy_pre     = $FORM{'selfcopy_pre'}     || q{};
    $subject_pre      = $FORM{'subject_pre'}      || q{};
    $contact_subjects = $FORM{'contact_subjects'} || q{};
    $en_contact_auto  = $FORM{'en_contact_auto'}  || 0;
    $contact_auto     = $FORM{'contact_auto'}     || q{};
    $contact_auto     = from_chars($contact_auto);
    $contact_auto     = to_html($contact_auto);
    $contact_auto =~ s/[\n\r]{1,2}/<br \/>/gxsm;
    $contact_auto  = to_chars($contact_auto);
    $autores_email = $FORM{'autores_email'} || q{};
    $autores_name  = $FORM{'autores_name'} || q{};
    $autores_pre   = $FORM{'autores_pre'} || q{};
    $contact_subjects =~ s/\r//gxsm;
    $contact_subjects =~ s/\n/|/gxsm;

    my $setfile = << "EOF";
###############################################################################
# ContactPage.txt (Contact Page configurations)                               #
###############################################################################

\$en_contactpage = $en_contactpage;
\$contact_email = '\Q$contact_email\E';
\$en_valimage = $en_valimage;
\$en_valquest = $en_valquest;
\$maxconmeslen = $maxconmeslen;
\$en_selfcopy = $en_selfcopy;
\$selfcopy_email = '\Q$selfcopy_email\E';
\$selfcopy_name = '\Q$selfcopy_name\E';
\$selfcopy_pre = '\Q$selfcopy_pre\E';
\$subject_pre = '\Q$subject_pre\E';
\$contact_subjects = '\Q$contact_subjects\E';
\$en_contact_auto = $en_contact_auto;
\$contact_auto = '$contact_auto';
\$autores_email = '\Q$autores_email\E';
\$autores_name = '\Q$autores_name\E';
\$autores_pre = '\Q$autores_pre\E';

1;
EOF

    our ($FILE);
    fopen( 'FILE', '>', "$vardir/Mods/ContactPage.txt" );
    print {$FILE} $setfile or croak "$croak{'print'} $setfile";
    fclose('FILE');

    require Admin::NewSettings;
    save_settings_to('Settings.pm');

    if ( $action eq 'contactpage2' ) {
        $yysetlocation = qq~$adminurl?action=contactpage~;
        redirectexit();
    }
    return;
}

1;
